******************************************************************************
*
*       Function:   GET_PROC_DEL
*       Usage:      stat = get_proc_del (stream_idx)
*       Purpose:    This routine initiates a read on the termination mailbox
*                   of the requesting stream that will complete whenever the
*                   process(es) that was/were created by this stream are
*                   deleted.
*       Output:     A pending QIO read.
*
******************************************************************************

        integer function get_proc_del (stream, proc)

            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'
            include '($accdef)'

            integer stream
            record /sub_proc/ proc
            external proc_deleted

            get_proc_del = sys$qio ( ,
     .                           %val(proc.delprchan),
     .                           %val(IO$_READLBLK),
     .                           proc.delprciosb,
     .                           proc_deleted,
     .                           %ref(proc.accnt),
     .                           %ref(proc.accnt.acc),
     .                           %val(ACC$K_TERMLEN), , , , )

        end
