******************************************************************************
*
*       Function:   PAUSE_TASK
*       Usage:      call pause_task (stream_id, data, request)
*       Purpose:    This routine is called by process() when it discovers
*                   that the JBC has sent us a pause task request.  This
*                   routine $SUSPND's the processes associated with the
*                   queue indicated by the passed stream identifier.
*       Output:     A suspended process, if one existed.
*
******************************************************************************

        subroutine pause_task (stream, data, request)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer stream, request, i, stat
            record /dynam/ data
            external sys$suspnd
            integer sys$suspnd

            last_idx = MAXPROCS+1

            do i=1,MAXPROCS
                if ((procs(i).avail .eq. .false.) .and.
     .                                      (procs(i).stream .eq. stream)) then

*                   Suspend the process for now

                    stat = sys$suspnd (procs(i).pid,)
                    if ((stat.and.1).ne.1) then
                        call log_str (%val (stat),
     .                                      'Can''t suspend process')
                    endif
                endif
            end do

*           Tell the JBC that the task is suspended.

            call reply (SS$_NORMAL, SMBMSG$K_PAUSE_TASK, stream)
        end
