******************************************************************************
*
*       Function:   REPLY
*       Usage:      call reply (vms_status, SMB_request, SMB_stream_id)
*       Purpose:    This routine is used to communicate the status of
*                   tasks/requests back to the JBC as needed.
*       Output:     The JBC gets the message passed.
*
******************************************************************************

        subroutine reply (status, request, stream)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer status, request, stream
            integer stats(1:2)
            external signal
            stats(1) = 1
            stats(2) = status

            call signal (smb$send_to_jobctl (stream, request, , ,
     .                                              SMBMSG$M_SERVER, stats))
        end

******************************************************************************
*
*       Function:   REPLY2
*       Usage:      call reply2 (vms_status1, vms_status2, SMB_request,
*                                SMB_stream_id)
*       Purpose:    This routine is used to communicate the status of
*                   tasks/requests back to the JBC as needed.  It differs
*                   from the above in that it allows two status values to 
*                   be sent to the JBC.
*       Output:     The JBC gets the message passed.
*
******************************************************************************

        subroutine reply2 (status1, status2, request, stream)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer status1, status2, request, stream
            integer stats(1:3)
            external signal
            stats(1) = 2
            stats(2) = status1
            stats(3) = status2

            call signal (smb$send_to_jobctl (stream, request, , ,
     .                                              SMBMSG$M_SERVER, stats))
        end
