******************************************************************************
*
*       Function:   START_STREAM
*       Usage:      call start_stream (SMB_stream_id, data_descr, SMB_request)
*       Purpose:    This routine is used to process START_STREAM requests from
*                   the JBC.  It initializes some things that need to be done
*                   before a queue can be started.  That is, it creates a
*                   termination mailbox, and it's associated unit number, and
*                   reads in the queue configuration information.
*       Output:     A new stream is ready to start.
*
******************************************************************************

        subroutine start_stream (stream, data, request)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'
            include '($syidef)'
            include '($pqldef)'

            integer stream, request
            record /dynam/ data

            integer i, prio
            character*2 prios(0:15) /'0','1','2','3','4','5','6','7','8',
     .                               '9','10','11','12','13','14','15'/
            external memfill, get_info, signal, reply, lib$getsyi

*           Zero out the structures.

            call memfill (streams(stream), %loc(streams(2))-%loc(streams(1)))

*           Get the information necessary, before an exception can occur,
*           because we must have the queue name and stuff.

            call get_info (stream, data, request, -1)


*           Initialize the stream specific configuration parameters

            call lib$getsyi (SYI$_DEFPRI, prio, , , , )
            streams(stream).proc_pri = prios(prio)
            streams(stream).pause_time = 0
            streams(stream).proc_spec = ' '
            streams(stream).user = 'SYSTEM'
            streams(stream).uic = cur_uic
            streams(stream).privs(1) = cur_privs(1)
            streams(stream).privs(2) = cur_privs(2)
            streams(stream).detached = .false.
            streams(stream).special = .false.
            streams(stream).quota_idx = 0
            streams(stream).quotas(1).type = PQL$_LISTEND
            streams(stream).use_sub_user = .false.
            streams(stream).outfile = INIT_LOG
            streams(stream).errfile = INIT_LOG
            streams(stream).expire = 600

*           Set the stream specific configuration parameters

            call get_queue_parms (stream)

*           Increment the number of active streams.

            num_streams = num_streams + 1

*           Tell the JBC that the stream is ready to accept work.

            call reply (SS$_NORMAL, SMBMSG$K_START_STREAM, stream)
        end
